#ifndef _LOCODEF_H
#define _LOCODEF_H

#include <stdint.h>
#include <stdio.h>

/* Global variables */


extern int embedpng;
extern int allinone;
extern char *filebase;


struct varinf {
	int ofs;
	int size;
	int num;
	const char *name;
	struct varinf *structvars;
	const char **flags;
};

struct spriteinf {
	uint32_t width,height,flags, spritesize;
	int32_t xofs,yofs;
};

struct useobjinf {
	int class;
	char *type, *obj;
};

struct xmlinf {
	int depth, maxdepth;

	int class, compression;
	uint32_t objdatasize, numuseobj, numcap, numsprites;

	uint8_t *objdata;
	struct useobjinf *useobj;
	uint8_t **caps;
	struct spriteinf *sprites;
	uint8_t **spritedata;

	struct varinf **curvars;
};


typedef uint32_t dumpproc(FILE*, uint8_t*);
typedef uint32_t parseproc(struct xmlinf*, uint8_t**);


#endif // ndef _LOCODEF_H
