
#include <string.h>

#include "common.h"
#include "dump.h"
#include "datstruc.h"


uint32_t dumpveh(FILE *xml, uint8_t *data)
{
  int i;
  uint32_t dumped;

  dumped = dumpvars(xml, data, vehvars);
  dumped += dumplang(xml, data+dumped);
  if ((data[2] < 2) && !(getvalue(data+0xE0, 2) & 0x200))
	dumped += dumpuseobj(xml, data+dumped, 0, 0, "tracktype", 0x11);
  for (i=0; i<data[6]; i++)
	dumped += dumpuseobj(xml, data+dumped, i, data[6], "trackmod", 0x10);
  for (i=0; i<2; i++)
	dumped += dumpcap(xml, data+dumped, i, 2);
  if (data[0x10F])
	dumped += dumpuseobj(xml, data+dumped, 0, 0, "visualeffect", 0x03);
  if (data[0x112])
	dumped += dumpuseobj(xml, data+dumped, 0, 0, "wakeeffect", 0x3);
  if ((data[2] < 2) && (data[0xE0]&0x40))
	dumped += dumpuseobj(xml, data+dumped, 0, 0, "rackrail", 0x10);
  for (i=0; i<data[15]; i++)
	dumped += dumpuseobj(xml, data+dumped, i, data[15], "compatible", 0x17);
  if (data[0x119])
	dumped += dumpuseobj(xml, data+dumped, 0, 0, "startsnd", 0x01);
  for (i=0; i<(data[0x15A] & 0x7f); i++)
	dumped += dumpuseobj(xml, data+dumped, i, data[0x15A] & 0x7f, "soundeffect", 0x01);
  dumped += dumpsprites(xml, data+dumped);

  return dumped;
}

uint32_t parseveh(struct xmlinf *info, uint8_t **dataout) {
  return 0;
}



dumpproc *dumpprocs[0x22] = {
	NULL,	// 00
	NULL,	// 01
	NULL,	// 02
	NULL,	// 03
	NULL,	// 04
	NULL,	// 05
	NULL,	// 06
	NULL,	// 07
	NULL,	// 08
	NULL,	// 09
	NULL,	// 0A
	NULL,	// 0B
	NULL,	// 0C
	NULL,	// 0D
	NULL,	// 0E
	NULL,	// 0F
	NULL,	// 10
	NULL,	// 11
	NULL,	// 12
	NULL,	// 13
	NULL,	// 14
	NULL,	// 15
	NULL,	// 16
	dumpveh,	// 17
	NULL,	// 18
	NULL,	// 19
	NULL,	// 1A
	NULL,	// 1B
	NULL,	// 1C
	NULL,	// 1D
	NULL,	// 1E
	NULL,	// 1F
	NULL,	// 20
	NULL,	// 21
};

parseproc *parseprocs[0x22] = {
	NULL,	// 00
	NULL,	// 01
	NULL,	// 02
	NULL,	// 03
	NULL,	// 04
	NULL,	// 05
	NULL,	// 06
	NULL,	// 07
	NULL,	// 08
	NULL,	// 09
	NULL,	// 0A
	NULL,	// 0B
	NULL,	// 0C
	NULL,	// 0D
	NULL,	// 0E
	NULL,	// 0F
	NULL,	// 10
	NULL,	// 11
	NULL,	// 12
	NULL,	// 13
	NULL,	// 14
	NULL,	// 15
	NULL,	// 16
	parseveh,	// 17
	NULL,	// 18
	NULL,	// 19
	NULL,	// 1A
	NULL,	// 1B
	NULL,	// 1C
	NULL,	// 1D
	NULL,	// 1E
	NULL,	// 1F
	NULL,	// 20
	NULL,	// 21
};
